#!/bin/sh
-set -x
append DRIVERS "atheros"
scan_atheros() {
;;
wds)
config_get addr "$vif" bssid
- ${addr:+append wds "$addr"}
+ config_get ssid "$vif" ssid
+ [ -z "$addr" -a -n "$ssid" ] && {
+ config_set "$vif" wds 1
+ config_set "$vif" mode sta
+ mode="sta"
+ addr="$ssid"
+ }
+ ${addr:+append $mode "$vif"}
;;
*) echo "$device($vif): Invalid mode, ignored."; continue;;
esac
done
- case "${adhoc:+1}:${sta:+}:${ap+1}" in
+ case "${adhoc:+1}:${sta:+1}:${ap+1}" in
# valid mode combinations
- 1::);;
+ 1::) wds="";;
:1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
:1:);;
::1);;
- :::);;
+ ::);;
*) echo "$device: Invalid mode combination in config"; return 1;;
esac
- config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${sta:+$sta }"
-
- [ -z "$adhoc" ] && config_set "$device" wds "$wdsifs"
+ config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${sta:+$sta }${wds:+$wds }"
}
+
disable_atheros() (
local device="$1"
+
+ # kill all running hostapd and wpa_supplicant processes that
+ # are running on atheros vifs
+ for pid in `pidof hostapd wpa_supplicant`; do
+ grep ath /proc/$pid/cmdline >/dev/null && \
+ kill $pid
+ done
include /lib/network
cd /proc/sys/net
grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
ifconfig "$dev" down
unbridge "$dev"
- wlanconfig $dev destroy
+ wlanconfig "$dev" destroy
}
done
+ return 0
)
enable_atheros() {
config_get channel "$device" channel
- config_get wds "$device" wds
config_get vifs "$device" vifs
-
+
+ disable_atheros "$device"
+ local first=1
for vif in $vifs; do
nosbeacon=
config_get ifname "$vif" ifname
config_get ifname "$vif" ifname
ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
- config_set "$vif" ifname "$ifname"
-
[ $? -ne 0 ] && {
- echo "enable_atheros($device): Failed to set up vif $ifname" >&2
+ echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
continue
}
+ config_set "$vif" ifname "$ifname"
+
+ [ "$first" = 1 ] && {
+ # only need to change freq band and channel on the first vif
+ config_get agmode "$device" mode
+ pureg=0
+ case "$agmode" in
+ *b) agmode=11b;;
+ *bg) agmode=11g;;
+ *g) agmode=11g; pureg=1;;
+ *a) agmode=11a;;
+ *) agmode=11g;;
+ esac
+ iwconfig "$ifname" channel 0
+ iwpriv "$ifname" mode "$agmode"
+ iwpriv "$ifname" pureg "$pureg"
+ iwconfig "$ifname" channel "$channel"
+ }
+
+ config_get_bool hidden "$vif" hidden
+ iwpriv "$ifname" hide_ssid "$hidden"
+
+ config_get wds "$vif" wds
+ case "$wds" in
+ 1|on|enabled) wds=1;;
+ *) wds=0;;
+ esac
+ iwpriv "$ifname" wds "$wds"
+
wpa=
case "$enc" in
WEP|wep)
iwconfig "$ifname" enc "[$idx]" "${key:-off}"
done
config_get key "$vif" key
- iwconfig "$ifname" enc "$key"
+ iwconfig "$ifname" enc "${key:-1}"
+ ;;
+ PSK|psk|PSK2|psk2)
+ config_get key "$vif" key
;;
esac
+
case "$mode" in
- ap)
- local hostapd_cfg=
- case "$enc" in
- *psk*|*PSK*)
- # FIXME: wpa
- ;;
- *wpa*|*WPA*)
- # FIXME: add wpa+radius here
- ;;
- esac
+ wds)
+ config_get addr "$vif" bssid
+ iwpriv "$ifname" wds_add "$addr"
;;
- sta)
- # FIXME: implement wpa_supplicant calls here
+ *)
+ config_get ssid "$vif" ssid
;;
- esac
-
- config_get ssid "$vif" ssid
- append if_up "iwconfig $ifname essid $ssid channel $channel" ";$N"
- append if_up "sleep 1" ";$N"
- append if_up "ifconfig $ifname up" ";$N"
-
+ esac
+
+ [ "$mode" = "sta" ] && {
+ config_get_bool bgscan "$vif" bgscan 1
+ iwpriv "$ifname" bgscan "$bgscan"
+ }
+
+ config_get_bool antdiv "$device" diversity 1
+ sysctl -w dev."$device".diversity="$antdiv" >&-
+
+ config_get antrx "$device" rxantenna
+ if [ -n "$antrx" ]; then
+ sysctl -w dev."$device".rxantenna="$antrx" >&-
+ fi
+
+ config_get anttx "$device" txantenna
+ if [ -n "$anttx" ]; then
+ sysctl -w dev."$device".txantenna="$anttx" >&-
+ fi
+
+ config_get distance "$device" distance
+ if [ -n "$distance" ]; then
+ athctrl -i "$device" -d "$distance" >&-
+ fi
+
+ config_get txpwr "$vif" txpower
+ if [ -n "$txpwr" ]; then
+ iwconfig "$ifname" txpower "${txpwr%%.*}"
+ fi
+
+ ifconfig "$ifname" up
+
local net_cfg bridge
net_cfg="$(find_net_config "$vif")"
[ -z "$net_cfg" ] || {
bridge="$(bridge_interface "$net_cfg")"
- append if_up "start_net '$ifname' '$net_cfg'" ";$N"
+ config_set "$vif" bridge "$bridge"
+ start_net "$ifname" "$net_cfg"
}
- # TODO: start hostapd
+ iwconfig "$ifname" essid "$ssid"
+ case "$mode" in
+ ap)
+ hostapd_setup_vif "$vif" madwifi || {
+ echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
+ # make sure this wifi interface won't accidentally stay open without encryption
+ ifconfig "$ifname" down
+ wlanconfig "$ifname" destroy
+ continue
+ }
+ ;;
+ wds|sta)
+ case "$enc" in
+ PSK|psk|PSK2|psk2)
+ case "$enc" in
+ PSK|psk)
+ proto='proto=WPA';;
+ PSK2|psk2)
+ proto='proto=RSN';;
+ esac
+ cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
+ctrl_interface=/var/run/wpa_supplicant
+network={
+ scan_ssid=1
+ ssid="$ssid"
+ key_mgmt=WPA-PSK
+ $proto
+ psk="$key"
+}
+EOF
+ ;;
+ WPA|wpa|WPA2|wpa2)
+ #add wpa_supplicant calls here
+ ;;
+ esac
+ wpa_supplicant ${bridge:+ -b $bridge} -Bw -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
+ ;;
+ esac
+ first=0
done
-
- #killall -KILL $hostapd >&- 2>&-
- eval "$if_up"
}
config wifi-device $dev
option type atheros
option channel 5
+# option diversity 1
+# option txantenna 0
+# option rxantenna 0
+# option distance 2000
+# disable radio to prevent an open ap after reflashing:
+ option disabled 1
+
config wifi-iface
- option device $dev
- option mode ap
- option ssid OpenWrt
- option hidden 0
+ option device $dev
+ option network lan
+ option mode ap
+ option ssid OpenWrt
+ option hidden 0
+# option txpower 15
+# option bgscan enable
option encryption none
EOF
done
}
-